local RM=LibStub("AceAddon-3.0"):GetAddon("Raid Mover");
local gs=LibStub("GuiSkin-1.0");
local spectype={
	["TANK"]= "TANK",
	["HEALER"]= "HEAL",
	["DAMAGER"]= "MDPS",
	buffs={
		["Shadowform"] = "RDPS",
		["Moonkin"] = "RDPS",
		["Stance of the Fierce Tiger"] = "MDPS",
		["Defensive Stance"] = "MDPS",
		["Berserker Stance"] = "MDPS",
		["Stance of the Sturdy Ox"] = "TANK",
		["Blood Presence"] = "TANK",
		["Righteous Fury"] = "TANK",
		["Defensive Stance"] = "TANK",
		["Stance of the Wise Serpent"] = "HEAL",
		["Chakra: Chastise"] = "HEAL",
		["Chakra: Sanctuary"] = "HEAL",
		["Chakra: Serenity"] = "HEAL",
	},
	chatformat={
		["RDPS"]=RM.color.CRIMSON.."RDPS|r",
		["TANK"]=RM.color.STEELBLUE.."TANK|r",
		["HEAL"]=RM.color.SPRINGGREEN.."HEAL|r",
		["MDPS"]=RM.color.CRIMSON.."MDPS|r",
	},
}
local roletexturepath={
	["roles"]=[[Interface\LFGFRAME\LFGROLE]],
	["RDPS"]={0.25,0.5,0,1},
	["TANK"]={0.5,0.75,0,1},
	["HEAL"]={0.75,1,0,1},
	["MDPS"]={0.25,0.5,0,1},
}
local v={}
--Need to return HEAL, TANK, MDPS, RDPS
function RM:CreateAutoMover()
	v=self.view
	v.auto={}
end
--Usage: RM:AutoMoverDisplay(RM:AutoPickGrp(RM:GatherSpecType()))
function RM:GatherSpecType()
	--v=self.view
	--v.auto={}
	local raidspecs={}
	local counter={}
	counter["TANK"]={}
	counter["MDPS"]={}
	counter["RDPS"]={}
	counter["HEAL"]={}
	--iterate over the raid, 
	for i=1, MAX_RAID_MEMBERS do
		--iterate through my buffscheck for buff
		local pname, _, class=RM:getPlayerInfo(i)
		if pname~=nil then
			raidspecs[pname]={}
			raidspecs[pname].class=class
			for specbuff, v in pairs(spectype.buffs) do
				local auraname=UnitAura("raid"..i, specbuff)
			end
			local role = UnitGroupRolesAssigned("raid"..i);
			if auraname then
				if spectype[role] ~= spectype.buffs[auraname] then
					RM:Print("Inconsistent results: "..auraname.." found on "..pname.." is a "..spectype.chatformat[spectype.buffs[auraname]].." ability , but set role is "..spectype.chatformat[spectype[role]]..". Setting role to raid assigned default: "..spectype.chatformat[spectype[role]]);
					raidspecs[pname].role=spectype[role]
					--counter[role]=counter[role]+1
					table.insert(counter[spectype[role]], pname)
				else
					RM:Print(auraname.." found on "..pname..", setting role as "..spectype.chatformat[spectype.buffs[auraname]])
					raidspecs[pname].role=spectype.buffs[auraname]
					--counter[spectype.buffs[auraname]]=counter[spectype.buffs[auraname]]+1
					table.insert(counter[spectype.buffs[auraname]], pname)
				end
			else
				local maxpower = UnitPowerMax("raid"..i , 0);
				--Need this to set DAMAGER as 'RDPS' to differentiate from 'MDPS' without assuming 300k means 'HEAL'
				if maxpower and maxpower>=300000 then
					RM:Print(pname.." has "..tostring(maxpower).." with default role "..spectype.chatformat[spectype[role]]..", setting RM role as "..spectype.chatformat["RDPS"])
					raidspecs[pname].role="RDPS"
					table.insert(counter.RDPS, pname)
				else
					--RM:Print("Defaulting "..pname.."'s RM role to "..spectype.chatformat[spectype[role]])--spectype[role])
					raidspecs[pname].role=spectype[role]
					table.insert(counter[spectype[role]], pname)
				end
			end
		end
	end
	
	--DEBUG PRINT COUNT!
	RM:Print("Tanks: "..counter["TANK"]..", MDPS: "..counter["MDPS"]..", RDPS: "..counter["RDPS"]..", Heals: "..counter["HEAL"])
	--
	return raidspecs, counter;
end

function RM:AutoPickGrp(raid, counter)
	
	local tempraid=raid
	-- local tanks={}
	-- local heals={}
	-- local rdps={}
	-- local mdps={}
	local playersPerGroup = {0,0,0,0,0,0,0,0}
	local puck=1
	-- for pname, ptable in pairs(tempraid) do
		-- if pname.role=="TANK" then
			-- table.insert(tanks, pname)
		-- elseif pname.role=="MDPS" then
			-- table.insert(mdps, pname)
		-- elseif pname.role=="RDPS" then
			-- table.insert(rdps, pname)
		-- elseif pname.role=="HEAL" then
			-- table.insert(heals, pname)
		-- end
	-- end
	
	function sortfunc(pname)
		if playersPerGroup[puck]<5 then
			playersPerGroup[puck]=playersPerGroup[puck]+1
			tempraid[pname].subgrp=puck
			RM:Print(pname.."("..tempraid[pname].role..") to grp "..puck)
		else
			puck=puck+1
			playersPerGroup[puck]=playersPerGroup[puck]+1
			tempraid[pname].subgrp=puck
			RM:Print(pname.."("..tempraid[pname].role..") to grp "..puck)
			
		end
	end
	
	-- for i=1, #tanks do
		-- sortfunc(tanks[i])
	-- end
	-- for i=1, #mdps do
		-- sortfunc(mdps[i])
	-- end
	-- for i=1, #rdps do
		-- sortfunc(rdps[i])
	-- end
	-- for i=1, #heals do
		-- sortfunc(heals[i])
	-- end
	
	for i=1, #counter.TANK do
		sortfunc(counter.TANK[i])
	end
	for i=1, #counter.MDPS do
		sortfunc(counter.MDPS[i])
	end
	for i=1, #counter.RDPS do
		sortfunc(counter.RDPS[i])
	end
	for i=1, #counter.HEAL do
		sortfunc(counter.HEAL[i])
	end
	
	return tempraid;
end

function RM:AutoMoverDisplay(layout)
		--Check for previous layout and clear and hide all frames(Wipe)
		if v.auto.templayout then
			RM:WipeAutoMover()
		end
		
		if type(layout) == "table" then
			v.auto.templayout = RM:deepCopy(layout, {})
		end
		
		local subgrp, class, role
		local points = {}
		points.x = {17, 153, 289, 17, 153, 289, 17, 153, 289}
		points.y = {-78, -78, -78, -178, -178, -178, -278, -278, -278}
		local yoffset = -18

--PLAYER BUTTON CREATION		
		for pname, ptable in pairs(v.auto.templayout) do
			subgrp, class, role = v.auto.templayout[pname].subgrp, v.auto.templayout[pname].class, v.auto.templayout[pname].role
--CREATE PLAYER FRAMES
			if not v.auto[pname.."frame"] then
				v.auto[pname.."frame"]=CreateFrame("Frame",RM.ver.."_AUTO"..pname.."frame",RM.mainFrame);
			end
			v.auto[pname.."frame"]:SetWidth(109);
			v.auto[pname.."frame"]:SetHeight(19);
			v.auto[pname.."frame"]:Show();
			v.auto[pname.."frame"]:EnableMouse(true);
			v.auto[pname.."frame"]:SetMovable(false);
			v.auto[pname.."frame"]:SetResizable(false);
			v.auto[pname.."frame"]:SetPoint('TOPLEFT',RM.mainFrame,'TOPLEFT',points.x[subgrp], points.y[subgrp])
			points.y[subgrp]=points.y[subgrp]+yoffset
			v.auto[pname.."frame"].selected=false;

----PLAYERNAME TEXT AND STATIC CLASS ICON
			
			if not v.auto[pname.."string"] then
				v.auto[pname.."string"]=v.auto[pname.."frame"]:CreateFontString(RM.ver.."_AUTO"..pname.."Text","ARTWORK","GameFontNormal")
			end
			if string.find(pname, "-") then
				v.auto[pname.."string"]:SetText(string.sub(pname,1,string.find(pname, "-")-1));
			else
				v.auto[pname.."string"]:SetText(pname);
			end
			v.auto[pname.."string"]:GetWidth()
			v.auto[pname.."string"]:SetFont([[Fonts\ARIALN.ttf]],16);
			v.auto[pname.."string"]:SetTextColor(RM.classcolor[class].r, RM.classcolor[class].g, RM.classcolor[class].b)
			v.auto[pname.."string"]:SetPoint("CENTER",v.auto[pname.."frame"],"CENTER",((v.auto[pname.."string"]:GetWidth()/2)-38),1)
			-- if not v.auto[pname..class.."Texture"] then
				-- v.auto[pname..class.."Texture"]=gs.CreateTexture(v.auto[pname.."frame"],self.ver.."_AUTO"..pname..class.."Texture","ARTWORK",18,36,"CENTER", v.auto[pname.."frame"], "CENTER", -47, 8,roletexturepath[class]);
			-- else
				-- v.auto[pname..class.."Texture"]:Show()
				-- v.auto[pname..class.."Texture"]:SetPoint("CENTER",v.auto[pname.."frame"],"CENTER",-47,8)
			-- end
			if not v.auto[pname..role.."Texture"] then
				v.auto[pname..role.."Texture"]=gs.CreateTexture(v.auto[pname.."frame"],self.ver.."_AUTO"..pname..role.."Texture","ARTWORK",12,12,"CENTER", v.auto[pname.."frame"], "CENTER", -47, 3,roletexturepath.roles);
				v.auto[pname..role.."Texture"]:SetTexCoord(roletexturepath[role][1],roletexturepath[role][2],roletexturepath[role][3],roletexturepath[role][4])
			else
				v.auto[pname..role.."Texture"]:Show()
				v.auto[pname..role.."Texture"]:SetPoint("CENTER",v.auto[pname.."frame"],"CENTER",-47,8)
			end
			
			
			--TESTING ROLE ICONS
			-- v.heals=gs.CreateTexture(RM.mainFrame,self.ver.."_HealsTexture","ARTWORK",12,12,"TOPLEFT", RM.mainFrame, "TOPLEFT", 80, -55,roletexturepath.roles);
			-- v.heals:SetTexCoord(roletexturepath["HEAL"][1],roletexturepath["HEAL"][2],roletexturepath["HEAL"][3],roletexturepath["HEAL"][4])
			-- v.dps=gs.CreateTexture(RM.mainFrame,self.ver.."_DPSTexture","ARTWORK",12,12,"TOPLEFT", RM.mainFrame, "TOPLEFT", 110, -55,roletexturepath.roles);
			-- v.dps:SetTexCoord(roletexturepath["RDPS"][1],roletexturepath["RDPS"][2],roletexturepath["RDPS"][3],roletexturepath["RDPS"][4])
			-- v.tank=gs.CreateTexture(RM.mainFrame,self.ver.."_TankTexture","ARTWORK",12,12,"TOPLEFT", RM.mainFrame, "TOPLEFT", 140, -55,roletexturepath.roles);
			-- v.tank:SetTexCoord(roletexturepath["TANK"][1],roletexturepath["TANK"][2],roletexturepath["TANK"][3],roletexturepath["TANK"][4])
			--
		end
end	

function RM:WipeAutoMover()
	if v.auto.templayout then
		for pname, ptable in pairs(v.auto.templayout) do
			if pname and v.auto[pname.."frame"] then
				v.auto[pname.."frame"]:Hide();
				v.auto[pname.."frame"]:ClearAllPoints()
			end
		end
		wipe(v.auto.templayout)
		v.auto.templayout=nil
	end
end














